<?php
add_action('admin_menu', 'add_product_config_menu');
function add_product_config_menu(){
   $icon=WPB_URL . 'resources/img/icon.png';
    add_menu_page( 'Product Builder', 'Product Builder', 'manage_product_terms', 'pc-part-page', 'get_pc_parts_page', $icon);
        add_submenu_page( 'pc-part-page', 'Product Builder Options', 'Options', 'manage_options', 'pc-part-page-opt',"get_pc_parts_opt_page");
}
	
function get_pc_parts_opt_page(){
        $pages = get_pages();

        if(isset($_POST['wpb_options'])){
                update_option("wpb_options", $_POST['wpb_options']);
        }
        $options=get_option("wpb_options");
?>
                <div class="wrap">
                        <h2><?php _e("Product Builder Options", 'wpb') ?></h2>
                        <form method="post">
                                <table class="form-table">
                                        <tr>
                                                <th scope="row"><label for="customizer_page"><?php _e("Customizer Page", 'wpb') ?></label></th>
                                                <td>
                                                        <select required id='customizer_page' name='wpb_options[customizer_page]'>
                                                                <option value><?php _e("Select customizer page", 'wpb') ?></option>
                                                                <?php
                                                                        if(!empty($pages)){
                                                                                foreach ($pages as $page) {

                                                                                        if(!empty($options)){
                                                                                                $selected=($options['customizer_page']==$page->ID)?"selected":"";
                                                                                        }else{
                                                                                                $selected="";
                                                                                        }

                                                                                        echo '<option '.$selected.' value="'.$page->ID.'">'.$page->post_title.'</option>';
                                                                                }	
                                                                        }
                                                                ?>
                                                        </select>
                                                </td>
                                        </tr>
                                </table>
                                <p class="submit">
                                        <input type="submit" name="submit" id="submit" class="button button-primary" value="<?php _e("Save Options", 'wpb') ?>">
                                </p>
                        </form>
                </div>
<?php 
}

function objectToArray($d) 
{
    if (is_object($d)) {
        $d = get_object_vars($d);
    }

    if (is_array($d)) {
        return array_map(__FUNCTION__, $d);
    } else {
        return $d;
    }
}

add_action( 'admin_enqueue_scripts', 'pc_enque_scripts' );
function pc_enque_scripts(){
            wp_enqueue_script("jquery-ui-sortable");
            wp_enqueue_media();
            wp_enqueue_script( 'pc_admin_js', WPB_URL . 'resources/js/admin-scripts.js' );
            wp_enqueue_style('pc-admin-css', WPB_URL . 'resources/css/admin-style.css');

                $product_config_data=objectToArray(json_decode(get_option('product_configurator')));

                if(isset($_GET["part"])){
                        $part=$product_config_data[$_GET["part"]]['data'];
                }else{
                        $part='';
                }
//                if(!empty($product_config_data)){
                        wp_localize_script( 'pc_admin_js', 'pc_active_part', $part );

//                }
                $message_array=array(
                        "add_cat_image"=>__( "Add option group", 'wpb' ),
                        "cancel"=>__( "Cancel", 'wpb' ),
                        "add_image"=>"Add option",
                        "image_type_error"=>__( "Please upload .png file", 'wpb' ),
                        "please_add_image"=>__( "Please add at least one option !", 'wpb' ),
                        "layer_added"=>__( "Option Added !", 'wpb' ),
                        "layer_updated"=>__( "Component successfully saved !", 'wpb' ),
                        "change_layer_icon"=>__( "Change component icon", 'wpb' ),
                        "enter_group_layer_name"=>__( "Please enter the component name", 'wpb' ),
                        "add_layer_image"=>__( "Please add component options !", 'wpb' ),
                        "confirm_part_delete"=>__( "Do you really want to delete this configuration?", 'wpb' ),
                        "confirm_layer_group_delete"=>__( "Do you really want to delete this component ?", 'wpb' ),
                        "hide"=>__( "Hide", 'wpb' ),
                        "deletes"=>__( "Delete", 'wpb' ),
                        "edit"=>__( "Edit", 'wpb' ),
                        "add_icon"=>__( "Set icon", 'wpb' ),
                        "add_layer_icon"=>__( "Add component icon", 'wpb' ),
                        "defaults"=>__( "Default", 'wpb' ),
                        "insert_icon"=>__( "Insert Icon", 'wpb' ),
                        "changes"=>__( "Change", 'wpb' ),
                        "names"=>__( "Name", 'wpb' ),
                        "price"=>__( "Price", 'wpb' ),
                        "change_icon"=>__( "Change Icon", 'wpb' ),
                        "close_msg"=>__( "Confirm Closing ?", 'wpb' ),
                        "drag_drop_msg"=>__( "Drag and drop to reorder", 'wpb' ),
                        "edit_img"=>__( "Edit image", 'wpb' ),
                        "image_used"=>__( "This picture has already been used in this configuration. You can't use it twice", 'wpb' )
                );
                wp_localize_script( 'pc_admin_js', 'message_array', $message_array );
}

add_action('admin_head','pc_admin_head');
function pc_admin_head(){
        if(isset($_GET["part"])){
                $product_config_data=objectToArray(json_decode(get_option('product_configurator')));
                $part=json_encode($product_config_data[$_GET["part"]]['data']);
                $part=$product_config_data[$_GET["part"]]['data'];
        }else{
                $part='';
        }
}

function get_part_table_list(){

        $product_config_data=objectToArray(json_decode(get_option('product_configurator')));
?>
        <div class='wrap'>
                <h2><?php _e( 'Products Configurations', 'wpb' ) ?> <a href="<?php echo admin_url('admin.php?page=pc-part-page&pc_action=new'); ?>" class="add-new-h2"><?php _e( 'Add New', 'wpb_pc' ) ?></a></h2>

                <table class="wp-list-table widefat fixed posts">
                <thead>
                    <tr>
                        <th scope="col"><?php _e( 'Name', 'wpb' ) ?></th>
                        <th scope=""></th>
                    </tr>
                </thead>

                <tbody id='the-list'>
<?php

        if(!empty($product_config_data)){
        $i=0;
        foreach ($product_config_data as $key => $product_config) {
                $class=($i%2)?"alternate":"";
?>
                                <tr class='<?php echo $class; ?> '>
                                        <td >
                                <a href="<?php echo admin_url('admin.php?page=pc-part-page&pc_action=edit&part='.$key); ?>">
                                        <?php echo $product_config['name']; ?>
                                </a>
                        </td>
                        <td align="right">
                                <a class='pc_delete_part' data-id='<?php echo $key; ?>' href='#'><?php _e("Delete");  ?></a>
                        </td>
                        </tr>
<?php
$i++;
        } }
?>             	
                </tbody>
                 <tfooter>
                    <tr>
                        <th scope="col"><?php _e( 'Name','wpb'  ) ?></th>
                        <th scope=""></th>
                    </tr>
                </tfooter>
                </table>
                </div>	
<?php

}

function pc_parts_editor(){
        $screen=get_current_screen();
//		global $message;
        $product_config_data=objectToArray(json_decode(get_option('product_configurator')));
        if(isset($_GET["part"])){
                $pc_active_part=$product_config_data[$_GET["part"]];

                $name=$pc_active_part['name'];
                echo "<input type='hidden' value='".$_GET["part"]."' id='pc_part_id' />";
        }else{
                $name="";
                $part_id="";
        }
        $list_id="";
        $page_name=(isset($_GET['pc_action'])&&$_GET['pc_action']=="new")?"Add Product Configuration":"Edit Product Configuration";
        ?>

        <div class='wrap'>
                <h2><?php echo $page_name ?></h2><br />
        <div id="pc-wrap">

                        <div class="modal" id="subscriber_modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">

                          <div class="modal-dialog">
                            <div class="modal-content">
                              <div class="modal-header">
                                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span></button>
                                <h4 class="modal-title" id="myModalLabel"><?php _e("Add component",'wpb');  ?></h4>
                              </div>
                              <div class="modal-body">
                                <div id="">

                                          </div>
                                        <input id='pc-partname' type="text" placeholder="Component name" />
                                        <div style="margin:10px 0 20px 0;">
<!--                                                        <label>
                                                                <input type="checkbox" name="" value="" id="part_mandatory"/>
                                                                <?php //_e('Mandatory', 'wpb' ) ?>
                                                                <img class='admin-help' title="<?php //_e("Mandatory Description",'wpb' ); ?>" src="<?php //echo WPB_URL."resources/img/help.png" ?>" />
                                                </label>-->
                                                <button id='add_layer_icon' data-id='' type="button" class="button"><?php _e("Add component icon",'wpb');  ?></button> 
                                                 </div>
                                                 <div class="wpb-layer-img">

                                                 </div>
                                        <hr />
                                        <div>
                                                        <input type="button" class='button' value="Add options group" id="pc_add_group"/> <img class='admin-help' title="<?php _e("Group description","wpb_orion"); ?>" style='top: 25px;' src="<?php echo WPB_URL."resources/img/help.png" ?>" />
                                                        <input type="button" class='button' value="Add option" id="pc_add_image"/> 
                                                        <div id="add-group-container">
                                                          <input type="text" placeholder="<?php _e("Group name","wpb");?>" id="pc-add-groupe-name"/>
                                                          <input type="button"  value="Add"  class='button'   id="pc-add-groupe-save"/>
                                                        </div>
                                                        <P><?php _e("Drag and drop items to reorder","wpb");?> </P>
                                                        <div id="pc-images-list">

                                                        </div>
                                                  </div>
                              </div>
                              <div class="modal-footer">
                                <input type="hidden" name="action" value="subscribe"/>
                                <input type="hidden" name="list_id" value="<?php echo $list_id; ?>"/>
                                <button id='save_part_btn' data-id='' type="button" class="button button-primary button-largey"><?php _e("Save component","wpb"); ?></button>
                              </div>
                            </div>
                          </div>
                        </div>


                        <div id="pc-part-title">
                                <label class='t-label'><?php _e("Name","wpb"); ?></label>	
                                <input id='group_part_name'  type='text' value="<?php echo str_replace("\\'","'", $name) ;?>" />
                        </div>
                        <div id="pc_preview"></div>

                        <input type="button" class='button action' value="Save" id="save_data"/>

                <div id="pc-part-container">
                        <a href='#' data-toggle="modal" id='add_part'>
                                <span><?php _e("Add component","wpb"); ?></span>
                        </a>
                        <ul id="pc-part-list"></ul>
                </div>
        </div>
        </div>
        <?php
}

function get_pc_parts_page(){
        if(isset($_GET['part']) || isset($_GET['pc_action'])){
                pc_parts_editor();
        }else{
                get_part_table_list();
        }
}

function insert_part($row_id,$name,$data){
        $product_config_data=objectToArray(json_decode(get_option('product_configurator'))); 
        //$product_config_data=objectToArray(json_decode($product_config_data));
        $insert_data=array("name"=>$name,"data"=>$data);

if(empty($product_config_data)){
    $i=0;
                $key=uniqid();
    $product_config_data[$key]=array("name"=>$name,"data"=>$data);
}else{
        if(isset($product_config_data[$row_id])){
                $key=$row_id;
                $product_config_data[$row_id]=$insert_data;
        }else{
                $key=uniqid();
                $product_config_data[$key]=$insert_data;
        }
}

update_option('product_configurator',json_encode($product_config_data));
echo admin_url("admin.php?page=pc-part-page&pc_action=edit&part=".$key);
        exit();
}

function delete_part($row_id){
        $product_config_data=objectToArray(json_decode(get_option('product_configurator')));
        if(isset($product_config_data[$row_id]))
            unset($product_config_data[$row_id]);
         update_option('product_configurator',json_encode($product_config_data));
        exit();
}

add_action( 'woocommerce_product_options_general_product_data', "get_producter_configurator" );
function get_producter_configurator(){
                $config_data=objectToArray(json_decode(get_option('product_configurator')));
                $none_state="";
                $product_id=  get_the_ID();
                if(isset($_GET['post'])){
//				$product_id=$_GET['post'];
                        $product_config=get_post_meta($product_id, "wpb_product_configurator",true);
                }else{
                        $product_config="";
                        $none_state="checked";
                }
                if(!empty($config_data)){
                        $product_config=get_post_meta($product_id, "wpb_product_configurator", true);
?>
<div id='wpb_product_config_list'>
        <strong>Product Configurator List</strong>
        <label>
                <input value="0" type="radio" <?php echo $none_state;  echo ($product_config==0)?" checked ":""; ?>  name='wpb_product_config' /> 
                None
         </label>
        <?php foreach ($config_data as $key =>  $config) { ?>
         <label>
                <input value="<?php echo  $key ?>" type="radio" <?php echo ($key==$product_config)?"checked":""; ?>  name='wpb_product_config' /> 
                <?php echo  $config['name'] ?>
         </label>  
        <?php }
                echo "</div>";
                }
}

add_action('save_post_product', 'wpb_save_product_config');
function wpb_save_product_config($product_id) {
    if(isset($_POST['wpb_product_config']))
        update_post_meta($product_id, "wpb_product_configurator", $_POST['wpb_product_config']);
}

add_action( 'woocommerce_after_add_to_cart_button', 'get_customize_btn');
function get_customize_btn($post_id=false){
    if(!$post_id)
        $post_id=get_the_ID();
    $product=  get_product($post_id);
        $product_config=get_post_meta($post_id, "wpb_product_configurator",true);

    if($product_config!="0"&&$product_config)
    {
        $config_id=get_POST_meta($post_id, "wpb_product_configurator",true);
        $options=get_option("wpb_options");
        $customier_page_url=add_query_arg(array('configurator_id' => $config_id, 'product_id' => $post_id),get_the_permalink($options['customizer_page']));

        ?>
        <a href="<?php echo $customier_page_url;?>" class="wpb-customize-product-link"> <?php _e("Build your own","wpb");?> </a>
       <?php
    }
}

add_filter("woocommerce_loop_add_to_cart_link","get_customize_btn_loop",10,2);
function get_customize_btn_loop($html,$product){
    $product_config=  get_post_meta($product->id,"wpb_product_configurator",true);
    if($product_config!="0"&&$product_config)
    {
        $html.='<input type="button" value="'.__("Build your own","wpb").'" data-id="'.$product->id.'" data-type="'.$product->product_type.'" class="wpb-customize-product"/>';
    }
    return $html;
}


function get_product_config_id($product_id){
        $config_id=get_post_meta($product_id,"wpb_product_configurator",true);
        if(strlen($config_id)>0){
                return $config_id;
        }else{
                return false;
        }
}

add_action("woocommerce_admin_order_item_values","get_order_custom_admin_data",10,3);
function get_order_custom_admin_data($_product, $item, $item_id )
{
    //var_dump($_product);
    if(!empty($_product)){
        
    
        if(!get_product_config_id($_product->id)) return;
        $variations=unserialize($item['wpb_data']);
        if(empty($variations)) return;
?>	
<script>
        jQuery(document).ready(function ($) {
                $('#order_items_list>tr').each(function(){
                        var item_id=$(this).attr("data-order_item_id");
                        if(item_id=="<?php echo $item_id ?>"){
                                var images="<div class='wpb-admin-des'><?php echo wpb_get_admin_custom_image($variations) ?></div>";
                                $(this).find('.thumb').html(images).css('width','200px');
                                //$(this).find('.display_meta').html("<?php echo wpb_get_admin_custom_layer_name($variations,$_product->id) ?>")
                        }



                });
        });
</script>

<?php 
}
}


function wpb_get_admin_custom_image($datas){
	$imgs="";
	foreach ($datas as $data) {
		$image=wp_get_attachment_image_src($data,"full");
		$imgs.="<img class='wpb-amin-custom-des' src='".$image[0]."' width='150' >";
	}
	return $imgs;
}

function wpb_get_admin_custom_layer_name($variations,$product_id){
	$config_id=get_product_config_id($product_id);
	$config_data=objectToArray(json_decode(get_option('product_configurator')));
	$config_data=$config_data[$config_id]['data'];
	$output="";
	foreach ($variations as $key => $variation) {
				$img_s=$config_data[$key]['img_s'];
				$find=false;
				if(!empty($img_s)){
					foreach ($img_s as $img) {
					
						if($img['img_id']==$variation){
							$find=true;
							$name=$img['img_name'];
							break;
						}
					}
				}
				
					if(!$find){
						$layer_categories=$config_data[$key]['category'];	
							if(!empty($layer_categories)){
								foreach ($layer_categories as $key => $layer_category) {
									$layer_category_imgs=$layer_category['img'];
									foreach ($layer_category_imgs as $key_img => $layer_category_img) {
										if($layer_category_img['img_id']){
											$name=$layer_category_img['img_name'];
										}
									}
								}
							}
					}
		
				$output.="<tr><th>".$config_data[$key]['name'] ."</th> : <td><p>". $name."</p></td></tr>";
			}
	return "<tbody>$output</tbody>";
}

function wpb_admin_notice() {
    $options=get_option("wpb_options");
    if(!isset($options['customizer_page']) || empty($options['customizer_page'])){
        ?>
        <div class="updated">
            <p><?php _e( "The Product Builder customizer page isn't set. please set it", 'wpb' ); ?> <a href="<?php echo get_admin_url()."admin.php?page=pc-part-page-opt";?>"><?php _e('here', 'wpb')?></a></p>
        </div>
        <?php
    }
    
}
add_action( 'admin_notices', 'wpb_admin_notice' );
?>