<?php
add_shortcode("wpb_builder", "get_wpb_builder");
//add_filter( 'the_content', 'wpb_get_customiser_page' );
function get_wpb_builder( $content ) {
	if(!isset($_GET['product_id'])) return $content;
	$options=get_option("wpb_options");
	$customier_page=$options['customizer_page'];
	global $post;
	if($post->ID == $customier_page){
		$custom_content=wpb_front_shortcode();
		$content.=$custom_content;
	}
	return $content;
  
}

add_filter("woocommerce_cart_item_thumbnail","get_wpb_thumbnail_data",10,3);
function get_wpb_thumbnail_data($thumbnail_code, $values, $cart_item_key){
	
	if(!empty($values['variation'])&&isset($values['variation']['wpb_data']))
        {
            //$variations=$values['variation'];
            $variations=$values['variation']['wpb_data'];
            $thumbnail_code= "<div class='wpb-item-thumbnail'>";
                    foreach ($variations as $variation) {
                            $image=wp_get_attachment_image_src($variation,"full");
                            $thumbnail_code.= "<img src='".$image[0]."' width='50' >";
                    }
            $thumbnail_code.= "</div>";
        }
    return $thumbnail_code;
}
add_filter("woocommerce_cart_item_name","get_wpb_thumbnail_title_data",10,3);
function get_wpb_thumbnail_title_data($name_code, $values, $cart_item_key){
	
	if(get_product_config_id($values['product_id']))
        {
//		$name_code.= $name_code;
		
		if(!empty($values['variation'])&&isset($values['variation']['wpb_data'])) 
                {
                    $variations=$values['variation'];
                    $name_code.= "<div class='wpb-cart-name'>";
                    foreach ($variations as $key => $variation) {
                        if(is_array($variation)) continue; 
                                $name_code.= "<span><b>".$key ."</b> : ". $variation."</span>";
                    }
                    $name_code.= "</div>";
                }
        }
    return $name_code;
		
}


function get_wpb_data_label($data,$product_id){
	$variations=$data;
		$config_id=get_product_config_id($product_id);
		$config_data=objectToArray(json_decode(get_option('product_configurator')));
		$config_data=$config_data[$config_id]['data'];
		$data_label=array();
		$currency_symbol=get_woocommerce_currency_symbol();
		foreach ($variations as $key => $variation) {
				$img_s=(isset($config_data[$key]['img_s'])?$config_data[$key]['img_s']:'');
				$part_name=$config_data[$key]['name'];
					$find=false;
					if(!empty($img_s)){
						foreach ($img_s as $img) {
							if($img['img_id']==$variation){
								$find=true;
								$name=$img['img_name'];
								$price=$img['img_price'];
								break;
							}
						}
					}
				
					if(!$find){
						$layer_categories=$config_data[$key]['category'];	
							if(!empty($layer_categories)){
								foreach ($layer_categories as $key => $layer_category) {
									$layer_category_imgs=$layer_category['img'];
									foreach ($layer_category_imgs as $key_img => $layer_category_img) {
										if($layer_category_img['img_id']==$variation){
											$name=$layer_category_img['img_name'];
											$price=$layer_category_img['img_price'];
										}
									}
								}
							}
					}
				$data_label[$part_name]=$name." (".$currency_symbol."".$price.")";
			}
	return $data_label;
}


add_action( 'woocommerce_before_calculate_totals', 'get_wpb_cart_item_price' );
function get_wpb_cart_item_price( $cart ) {
	$config_data_array=objectToArray(json_decode(get_option('product_configurator')));
	
    foreach ( $cart->cart_contents as $cart_item_key => $cart_item ) {
			$config_id=get_product_config_id($cart_item['product_id']);
			if($config_id!=false)
                        {
                            $config_data=$config_data_array[$config_id];
                            if(!isset($cart_item['variation']['wpb_data']))
                                continue;
		
                            $wpb_data=$cart_item['variation']['wpb_data'];
                            $product=get_product($cart_item['product_id']);
                            $product_price=$product->get_price();
                            $price=floatval ($product_price);

                            foreach ($wpb_data as $key => $variation) {
                                $img_s=(isset($config_data['data'][$key]['img_s'])?$config_data['data'][$key]['img_s']:'');
                                    $find=false;
                                if(!empty($img_s))
                                {
                                    foreach ($img_s as $img) {
                                        if($img['img_id']==$variation){
                                                $find=true;
                                                $price+=floatval ($img['img_price']);
                                        }
                                    }
                                }
                                if(!$find && isset($config_data['data'][$key]['category'])){
                                    $layer_categories=$config_data['data'][$key]['category'];				
                                    if(!empty($layer_categories))
                                    {
                                        foreach ($layer_categories as $key => $layer_category) {					
                                            if(!empty($layer_category)){
                                                $layer_category_imgs=$layer_category['img'];
                                                if(!empty($layer_category_imgs)){
                                                    foreach ($layer_category_imgs as $key_img => $layer_category_img) {
                                                        if($layer_category_img['img_id']==$variation){
                                                                $price+=floatval  ($layer_category_img['img_price']);
                                                        }
                                                    }
                                                }
                                            }

                                        }
                                    }
                                }


                            }
			$cart_item['data']->price=$price;			
		}
    }
}



//add_filter("woocommerce_order_item_quantity_html", "get_user_account_products_meta",11,2);
//function get_user_account_products_meta($output, $item)
//{
//	
//	if(!isset($item['item_meta']['wpb_data'])){
//		return $output;
//	}
//	$wp_data=unserialize($item['item_meta']['wpb_data'][0]);
//	$product_id=$item['item_meta']['_product_id'][0];
//	
//	$config_data=objectToArray(json_decode(get_option('product_configurator')));
//	$config_data=$config_data[get_product_config_id($product_id)];
////	 ob_start();
//	
//	foreach ($wp_data as $key => $variation) {
//			if(is_array($variation)) continue; 
//				$img_s=$config_data['data'][$key]['img_s'];
//					$find=false;
//				foreach ($img_s as $img) {
//				
//					if($img['img_id']==$variation){
//						$find=true;
//						$name=$img['img_name'];
//						break;
//					}
//				}
//					if(!$find){
//						$layer_categories=$config_data['data'][$key]['category'];	
//							if(!empty($layer_categories)){
//								foreach ($layer_categories as $key => $layer_category) {
//									foreach ($layer_category_imgs as $key_img => $layer_category_img) {
//										if($layer_category_img['img_id']){
//											$name=$layer_category_img['img_name'];
//										}
//									}
//								}
//							}
//					}
//		
//				$output.= "<span><b>".$config_data[$key]['name'] ."</b> : ". $name."</span>";
//			}
////		ob_end_clean();
//		return $output;
//
//    
//}


function wpb_front_shortcode(){
	$config_id=$_GET['configurator_id'];
	$product_id=$_GET['product_id'];
	$config_data=objectToArray(json_decode(get_option('product_configurator')));
	$config_data=$config_data[$config_id];
	if(!isset($config_data)) return;
	$name=$config_data['name'];
	$layers=$config_data['data'];
	$default_images=array();
	$image_data=array();
	$product=get_product($product_id);
	$product_price=$product->get_price();
	$currency_icon=get_woocommerce_currency_symbol(); 
	ob_start();
?>
	<div class='onerow' id="wpb_global_wrap" data-config='<?php echo $config_id ?>'>
	  	<div id='layer_settings' class='col3'>
		  <?php
		  foreach ($layers as $layer_key => $layer) {
		  	//var_dump($layer);
		  	$default_images[]=array(
				"img_url"=>$layer['defaul_img_url'],			
				"defaul_img_id"=>$layer['defaul_img'],
				"layer_id"=>$layer_key,
				"img_id"=>$layer['defaul_img']
			);
		  	?>
			  <div class='layer_set_wrap' id='layer_wrap_<?php echo $layer_key ?>' data-id='<?php echo $layer_key ?>'>
				<h3 id='h3_<?php echo $layer_key ?>'>
					<?php $layer_icon=(isset($layer['layer_icon']) && $layer['layer_icon']!='0' )? "background: url(".$layer['layer_icon'].")  no-repeat center center":"" ?>
					<div class="layer_icon_name" style="<?php echo $layer_icon ?>">
						
					</div>
					<span><?php echo $layer['name'] ?></span>
					<span class='selected_text'></span>
					<span class='selected_icon'></span>
				</h3>
				
				<div class="layer_icon_wrap">
				  <?php 
                                        $layer_categories=array();
                                        if(isset($layer['category']))
                                            $layer_categories=$layer['category'];
					
					if(!empty($layer_categories)){
						//var_dump($layer_categories);
						echo "<table>";
						foreach ($layer_categories as $key => $layer_category) {
							echo "<tr><td class='wpb-cat-wrap'>".$layer_category['name']."</td>";
							$layer_category_imgs=$layer_category['img'];
							echo "<td class='wpb-cat-icon'>";
							foreach ($layer_category_imgs as $key_img => $layer_category_img) {
								echo "<img width='24'  data-layer='".$layer_key ."' data-id='".$layer_category_img['img_id']."' data-title='".$layer_category_img['img_name']." (".$currency_icon.$layer_category_img['img_price'].")'  title='".$layer_category_img['img_name']." (".$currency_icon.$layer_category_img['img_price'].")'  class='layer_icon' src='".$layer_category_img['icon_url']."'>";
								$image_data[$layer_category_img['img_id']]=array("img_url"=>$layer_category_img['img_url'],"image_price"=>$layer_category_img['img_price']);
								$img_url=$layer_category_img['img_url'];
								$img_price=$layer_category_img['img_price'];
								$img_id=$layer_category_img['img_id'];
								$img_name=$layer_category_img['img_name'];
							?>
							<script>image_data['<?php echo $img_id ?>']={'img_url':'<?php echo $img_url ?>','img_price':'<?php echo $img_price; ?>','img_id':'<?php echo $img_id; ?>','img_name':'<?php echo $img_name; ?>'}</script>
							<?php 
							}
							echo "</td></tr>";
							
						}
						echo "</table>";
					}
					
					$layer_imgs=(isset($layer['img_s'])?$layer['img_s']:'');
					if(!empty($layer_imgs)){
						foreach ($layer_imgs as $key => $layer_img) {
								//var_dump($layer_img);
								echo "<img data-title='".$layer_img['img_name']." (".$currency_icon.$layer_img['img_price'].")' Title='".$layer_img['img_name']." (".$currency_icon.$layer_img['img_price'].")' data-layer='".$layer_key ."' data-id='".$layer_img['img_id']."' width='24' class='layer_icon' src='".$layer_img['icon_url']."'>";
								$image_data[$layer_img['img_id']]=array("img_url"=>$layer_img['img_url'],"image_price"=>$layer_img['img_price']);	
								$img_url=$layer_img['img_url'];
								$img_price=$layer_img['img_price'];
								$img_id=$layer_img['img_id'];
								$img_name=$layer_img['img_name'];
						?>
							<script>image_data['<?php echo $img_id ?>']={'img_url':'<?php echo $img_url ?>','img_price':'<?php echo $img_price; ?>','img_id':'<?php echo $img_id; ?>','img_name':'<?php echo $img_name; ?>'}</script>
					<?php 
						}
						echo "</table>";
					}
					
				  ?>
				</div>
			  </div>
			<?php

		  }
		  ?>
		</div>
		<div id='layer_container' class='col9'>
		  	<div id="add_cart_wrap">
				<div id="add_cart_div">
				  	<span style='font-weight: normal;color:#768e9d'>Total Price : </span>
				  	<?php echo get_woocommerce_currency_symbol();  ?><span id='wpb_image_price'><?php echo $product_price;  ?></span>	
				</div>
			 </div>
			 <div id="layer_image_container">
			   <?php
			   $i=0;
			   	foreach ($default_images as $image) {
					   echo "<img id='".$image['layer_id']."' data-id='".$image['img_id']."' class='layer_img' src='".$image['img_url']."' >";
					if($i==0){
						echo "<img  style='visibility: hidden !important;' src='".$image['img_url']."' >";
					}
					$i++;
				   }
			   ?>
			 </div>
			 <div style='margin-top: 20px; position: relative'>
			 	<div class='animated' id="wpb_front_message"></div>
			 	<a data-id="<?php echo  $_GET['product_id']; ?>" id='wpb_add_cart' href='#'>Add To Cart</a>
			 	<input type="text" value="1" id='wpb_qt_txt' />
			 </div>
		</div>
	</div>
	<script type="text/javascript" charset="utf-8">
		product_price="<?php echo $product_price;  ?>";
		//console.log(image_data)
	</script>
<?php 	
	$output= ob_get_contents();
    ob_end_clean();
    return $output;
}
add_shortcode("pc_front_shortcode", "wpb_front_shortcode");

add_action('wp_enqueue_scripts', 'get_wpb_front_scripts');
function get_wpb_front_scripts() {
    wp_enqueue_script('jquery');
    
    wp_register_script('wpb-js', WPB_URL . 'resources/js/scripts.js');
    wp_enqueue_script('wpb-js', array('jquery'), false, false);
    
    wp_localize_script( 'wpb-js', 'ajax_object',
            array( 'ajax_url' => admin_url( 'admin-ajax.php' )) );
    
    
    
    
    wp_register_style('wpb-css', WPB_URL . 'resources/css/front.css', array(), '1.0', 'all');
    wp_enqueue_style('wpb-css');
    
    wp_register_style('simplegrid-css', WPB_URL . 'resources/css/simplegrid.css', array(), '1.0', 'all');
    wp_enqueue_style('simplegrid-css');
}

add_shortcode('wpb-products','get_wpb_products_display');
function get_wpb_products_display($atts){
    extract( shortcode_atts( array(
		'cat' => '',
                'products' => '',
                'cols' => '3'
	), $atts, 'wpb-products' ) );
    $args = array( 
            'posts_per_page' => 12, 
            'post_type'=> 'product',
            'product_cat'=>$cat,
            'meta_query'=> array(
                                    array(
                                        'key' => 'wpb_product_configurator',
                                        'value' => '',
                                        'compare'=> '!='
                                        )
                                )
            );
                $product_arr=array();
            if(!empty($products))
            {
                $product_arr=  explode(",", $products);
                $args["post__in"]= $product_arr;
            }
    $products = get_posts( $args );
    
    ob_start();
        
?>
	<div class='container wp-products-container wpb-grid wpb-grid-pad'>
<?php
	
	$shop_currency_symbol=get_woocommerce_currency_symbol();
        foreach ($products as $product) 
        {
            $prod=get_product($product->ID);
        ?>
            <div class='wpb-col-1-<?php echo $cols;?> cat-item-ctn'>
                    <div class='cat-item'>
                            <h3><?php  echo $product->post_title; ?> <span><?php echo $shop_currency_symbol.''.$prod->price ?></span></h3>
                            <?php  echo get_the_post_thumbnail($product->ID, 'medium'); ?>
                            <hr>
                            <?php get_customize_btn($product->ID);?>
                    </div>
            </div>
        <?php 
        }
            ?>
	</div>
        <?php
        $output=  ob_get_contents();
        ob_end_clean();
        return $output;
}

//add_action('woocommerce_checkout_order_processed', 'wpb_add_order_post', 10, 2);
//function wpb_add_order_post($order_id, $posted){
//    $wpb_post_title = $posted['billing_first_name'].' '.$posted['billing_last_name'];
//    //var_dump($posted);
//    global $woocommerce;
//    $items = $woocommerce->cart->get_cart();
//    $img_dim = array();
//    $final_image = '';
//    
//    foreach($items as $item_id => $product_data){ 
//        $imgs = array();
//        var_dump($product_data['variation']);
//        foreach ($product_data['variation']['wpb_data'] as $key => $img_id) {
//            $image=wp_get_attachment_image_src($img_id,"full");
//            $imgs[]=$image[0];
//        }
//        $item_merged_img = merge_transparent_png($imgs);
//        echo $item_merged_img;
//        // Create post object
//        $my_post = array(
//          'post_title'    => $wpb_post_title,
//          'post_content'  => $posted['order_comments'],
//          'post_status'   => 'publish',
//          'post_author'   => 1,
//          'post_category' => array( 8,39 )
//        );
//
//        // Insert the post into the database
//        $post_id = wp_insert_post( $my_post );
//        //add attached img
//        if ($post_id){
//            // Check the type of tile. We'll use this as the 'post_mime_type'.
//            $filetype = wp_check_filetype( basename( $item_merged_img ), null );
//
//            // Get the path to the upload directory.
//            $wp_upload_dir = wp_upload_dir();
//
//            // Prepare an array of post data for the attachment.
//            $attachment = array(
//                    'guid'           => $wp_upload_dir['url'] . '/' . basename( $item_merged_img ), 
//                    'post_mime_type' => $filetype['type'],
//                    'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $item_merged_img ) ),
//                    'post_content'   => '',
//                    'post_status'    => 'inherit'
//            );
//
//            // Insert the attachment.
//            $attach_id = wp_insert_attachment( $attachment, $item_merged_img, $post_id );
//
//            // Make sure that this file is included, as wp_generate_attachment_metadata() depends on it.
//            require_once( ABSPATH . 'wp-admin/includes/image.php' );
//
//            // Generate the metadata for the attachment, and update the database record.
//            $attach_data = wp_generate_attachment_metadata( $attach_id, $item_merged_img );
//            wp_update_attachment_metadata( $attach_id, $attach_data );
//            set_post_thumbnail( $post_id, $attach_id );
//            $post_page = get_permalink( $post_id );
//            var_dump($post_page);
//            
//            if($post_page!=false){
//                add_filter( 'woocommerce_thankyou_order_received_text', function( $text, $order ) {
//                    $msg = '<p>Some post have been created to show your custom desing <a href="'.$post_page.'">there</a></p>';
//                    var_dump($text);
//                    return $text . $msg;
//                }, 10, 2 );
//            }
//            die();
//
//        }     
//          
//    }
//    //die();
//}
//
//function merge_transparent_png($imgs) {
//    $img_dim = getimagesize($imgs[0]);
//    $output_img = imagecreatefrompng($imgs[0]);
//    imagealphablending($output_img, true);
//    imagesavealpha($output_img, true);
//    for ($index = 1; $index < count($imgs); $index++) {
//        $img = imagecreatefrompng($imgs[$index]);
//        imagecopy($output_img, $img, 0, 0, 0, 0, $img_dim[0], $img_dim[0]);
//    }
//    $upload_dir = wp_upload_dir();
//    if (!file_exists($upload_dir['path'].'/WPB/')) {
//        mkdir($upload_dir['path'].'/WPB/', 0777, true);
//    }
//
//    $output_img_name = 'ordered_item_'.uniqid().'.png';
//    imagepng($output_img, $upload_dir['path'].'/WPB/'.$output_img_name);
//    //$output_img_url = $upload_dir['url'].'/WPB/'.$output_img_name;
//    return $upload_dir['path'].'/WPB/'.$output_img_name;
//}
?>