<?php
/*
	Plugin Name:   Woocommerce Products Builder
	Description:  A super simple woocommerce extension which helps the customer to design his perfect product (shirts, shoes, business cards...) before order
	Version: 0.6
	Author: Orion
	Author URI: http://orionorigin.com/
*/




define( 'WPB_URL', plugins_url('/', __FILE__) );
define( 'WPB_DIR', dirname(__FILE__) );
define( 'WPB_VERSION', '0.1' );

// Adding Translation Option
load_theme_textdomain( 'wpb', WPB_DIR.'/languages' );
$locale = get_locale();
$locale_file = WPB_DIR."/languages/$locale.php";
if ( is_readable($locale_file) ) require_once($locale_file);



//global $message;
//$message['Mandatory Description'];
require_once( WPB_DIR . DIRECTORY_SEPARATOR . 'inc' . DIRECTORY_SEPARATOR . 'ajax.php' );
require_once( WPB_DIR . DIRECTORY_SEPARATOR . 'inc' . DIRECTORY_SEPARATOR . 'admin.php' );
require_once( WPB_DIR . DIRECTORY_SEPARATOR . 'inc' . DIRECTORY_SEPARATOR . 'front.php' );
require_once( WPB_DIR . DIRECTORY_SEPARATOR . 'inc' . DIRECTORY_SEPARATOR . 'woocp.php' );

register_activation_hook(__FILE__, 'wpb_activation');
function wpb_activation() {
	if ( !in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
		$notices= get_option('wpb_c_notice', array());
		$notices[]= "Woo Products Builder : You must install Woocommerce Plugin";
		update_option('wpb_c_notice', $notices);
	}
 
}

add_action('admin_notices', 'get_wpb_admin_notices');
function get_wpb_admin_notices() {
  if ($notices= get_option('wpb_c_notice')) {
    foreach ($notices as $notice) {
      echo "<div class='error'><p>$notice</p></div>";
    }
    delete_option('wpb_c_notice');
  }
}

register_deactivation_hook(__FILE__, 'wpb_deactivation');
function wpb_deactivation() {
  delete_option('wpb_c_notice'); 
}